Index: squid/src/Plaxton.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/Plaxton.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid/src/Plaxton.c	20 Nov 2001 06:59:14 -0000	1.1.2.1
+++ squid/src/Plaxton.c	21 May 2002 02:46:42 -0000	1.1.2.2
@@ -2133,50 +2150,50 @@
 static void
 stressTestParents(void)
 {
-  int ii;
-  URLKey targetURLKey;
-  int qIndex, iamRoot;
-  static int BIG = 100; /* should be much bigger for good test */
-  struct sockaddr_in sin, retAddr;
-
-  plaxtonInit(4);
-
-  for(ii = 0; ii < BIG; ii++){
-    sin.sin_addr.s_addr = 100000 + ii;
-    sin.sin_port = 0;
-    HCHier_newNode(&sin, 1000, 999);
-  }
-
-  for(ii = 0; ii < BIG; ii++){
-    sin.sin_addr.s_addr = 100000 + ii;
-    sin.sin_port = 0;
-    plaxtonchangeDistance(&sin);
-  }
-
-
-  for(ii = 0; ii < BIG; ii++){
-    targetURLKey.key = ii;
-    qIndex = plaxtonParentQIndex(&targetURLKey, &iamRoot);
-    if(!iamRoot){
-      assert(!plaxtonGetParentAddr(qIndex, &retAddr));
-    }
-  }
-
-  for(ii = 0; ii < BIG; ii++){
-    sin.sin_addr.s_addr = 100000 + ii;
-    sin.sin_port = 0;
-    HCHier_delNode(&sin, 1000, 1999);
-  }
-
-  for(ii = 0; ii < BIG; ii++){
-    targetURLKey.key = ii;
-    qIndex = plaxtonParentQIndex(&targetURLKey, &iamRoot);
-    if(!iamRoot){
-      assert(!plaxtonGetParentAddr(qIndex, &retAddr));
+    int ii;
+    URLKey targetURLKey;
+    int qIndex, iamRoot;
+    static int BIG = 100;	/* should be much bigger for good test */
+    struct sockaddr_in sin, retAddr;
+
+    plaxtonInit(4);
+
+    for (ii = 0; ii < BIG; ii++) {
+	sin.sin_addr.s_addr = 100000 + ii;
+	sin.sin_port = 0;
+	HCHier_newNode(&sin, 1000, 999);
     }
-  }
 
-  plaxtonDestroy();
+    for (ii = 0; ii < BIG; ii++) {
+	sin.sin_addr.s_addr = 100000 + ii;
+	sin.sin_port = 0;
+	plaxtonchangeDistance(&sin);
+    }
+
+
+    for (ii = 0; ii < BIG; ii++) {
+	targetURLKey.key = ii;
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iamRoot);
+	if (!iamRoot) {
+	    assert(!plaxtonGetParentAddr(qIndex, &retAddr));
+	}
+    }
+
+    for (ii = 0; ii < BIG; ii++) {
+	sin.sin_addr.s_addr = 100000 + ii;
+	sin.sin_port = 0;
+	HCHier_delNode(&sin, 1000, 1999);
+    }
+
+    for (ii = 0; ii < BIG; ii++) {
+	targetURLKey.key = ii;
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iamRoot);
+	if (!iamRoot) {
+	    assert(!plaxtonGetParentAddr(qIndex, &retAddr));
+	}
+    }
+
+    plaxtonDestroy();
 }
 
 
@@ -2203,121 +2220,126 @@
  *
  *------------------------------------------------------------------
  */
-static void 
+static void
 testParentsInternals(void)
 {
-  int ii, targetKey;
-  NodeKey anotherNodeKey, *current, *next;
-  GenericKey k;
-  struct sockaddr_in sin, nodes[16];
-  int iAmRoot;
-  URLKey urlKey;
+    int ii, targetKey;
+    HintCacheNodeKey anotherNodeKey, *current, *next;
+    HintCacheKey k;
+    struct sockaddr_in sin, nodes[16];
+    int iAmRoot;
+    URLKey urlKey;
+    dlink_node *node;
+
+    plaxtonInit(2);
+    myNodeKey = 0;		/* Fake it out to make tests easier to write and read */
+
+    targetKey = 1;
+    ii = 0;
+    while (targetKey < 16) {
+	/*
+	 * Note: netdb only keeps distance info on granularity of
+	 * networks; we want to know what distances there are between
+	 * nodes, so make nodes be on different (hopfully unused) subnets
+	 */
+	sin.sin_addr.s_addr = 15000 + ii * 255;
+	sin.sin_port = 0;
+	if (netdbHintHops(sin.sin_addr))
+	    !=0) {
+	    ii++;
+	    continue;		/* Someone already used this address and gave it a distance */
+	    }
+	hintCacheNodeKeyInit(&anotherNodeKey, &sin);
+	if ((anotherNodeKey.key & 15) == targetKey) {
+	    nodes[targetKey] = sin;
+	    HCHier_newNode(&sin, targetKey * 1000, 999);
+	    targetKey++;
+	}
+	ii++;
+    }
 
-  plaxtonInit(2);
-  myNodeKey = 0;   /* Fake it out to make tests easier to write and read */
+    /*
+     * The level-0 lists should be in sorted order
+     */
+    for (ii = 1; ii <= 3; ii++) {
+	for (node = parentListA[ii].head; node; node = node->next) {
+	    current = node->data;
+	    if (current != (HintCacheNodeKey *) parentListA[ii].tail->data)) {
+		next = (HintCacheNodeKey *) List_Next((dlink_node *) current);
+		assert(!List_IsAtEnd(&parentListA[ii], (dlink_node *) next));
+		assert(HCHier_compareDistanceFromMe(hintCacheNodeKeyGetAddr(current).
+			sin_addr, hintCacheNodeKeyGetAddr(next).sin_addr)
+		    <= 0);
+	    }
+	}
+    }
 
-  targetKey = 1; ii = 0;
-  while(targetKey < 16){
     /*
-     * Note: netdb only keeps distance info on granularity of
-     * networks; we want to know what distances there are between
-     * nodes, so make nodes be on different (hopfully unused) subnets
+     * The level-0 lists XX01, XX10, and XX11 should each have
+     * four elements in the following order: 00--, 01--, 10--,
+     * and 11-- (where "--" is the index of the list)
+     */
+    for (ii = 1; ii <= 3; ii++) {
+	assert((&parentListA[ii])->prevPtr
+	    == (&parentListA[ii])->nextPtr->nextPtr->nextPtr->nextPtr);
+
+	k = ((HintCacheNodeKey *) ((&parentListA[ii])->nextPtr))->key;
+	assert((k & 3) == ii);
+	assert(((k & 15) >> 2) == 0);	/* 00 */
+
+	k = ((HintCacheNodeKey *) ((&parentListA[ii])->nextPtr->nextPtr))->key;
+	assert((k & 3) == ii);
+	assert(((k & 15) >> 2) == 1);	/* 01 */
+
+	k = ((HintCacheNodeKey *) ((&parentListA[ii])->nextPtr->nextPtr->nextPtr))->key;
+	assert((k & 3) == ii);
+	assert(((k & 15) >> 2) == 2);	/* 10 */
+
+	k = ((HintCacheNodeKey *) ((&parentListA[ii])->nextPtr->nextPtr->nextPtr->
+		nextPtr))->key;
+	assert((k & 3) == ii);
+	assert(((k & 15) >> 2) == 3);	/* 11 */
+
+	urlKey.key = 0xFFAA3400 | ii;
+	assert(plaxtonCheckIfParent(urlKey, &nodes[ii]));
+	assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == ii);
+	assert(!iAmRoot);
+    }
+    /*
+     * The level-1 lists 0100, 1000, 1100 should each
+     * have one element
      */
-    sin.sin_addr.s_addr = 15000 + ii*255;
-    sin.sin_port = 0;
-    if(netdbHintHops(sin.sin_addr)) != 0){
-      ii++;
-      continue; /* Someone already used this address and gave it a distance */
-    }
-    NodeKey_Init(&anotherNodeKey, &sin);
-    if((anotherNodeKey.key & 15) == targetKey){
-      nodes[targetKey] = sin;
-      HCHier_newNode(&sin, targetKey*1000, 999);
-      targetKey++;
-    }
-    ii++;
-  }
-
-  /*
-   * The level-0 lists should be in sorted order
-   */
-  for(ii = 1; ii <= 3; ii++){
-    LIST_FORALL2(&parentListA[ii], NodeKey *, current){
-      if(current != (NodeKey *)List_Last(&parentListA[ii])){
-	next = (NodeKey *)List_Next((List_Links *)current);
-	assert(!List_IsAtEnd(&parentListA[ii], (List_Links *)next));
-	assert(HCHier_compareDistanceFromMe(NodeKey_GetAddr(current).sin_addr,
-					    NodeKey_GetAddr(next).sin_addr)
-	       <= 0);
-      }
-    }
-  }
-
-  /*
-   * The level-0 lists XX01, XX10, and XX11 should each have
-   * four elements in the following order: 00--, 01--, 10--,
-   * and 11-- (where "--" is the index of the list)
-   */
-  for(ii = 1; ii <= 3; ii++){
-    assert((&parentListA[ii])->prevPtr 
-	   == (&parentListA[ii])->nextPtr->nextPtr->nextPtr->nextPtr);
-
-    k = ((NodeKey *)((&parentListA[ii])->nextPtr))->key;
-    assert((k & 3) == ii);
-    assert(((k & 15) >> 2) == 0); /* 00 */
-
-    k = ((NodeKey *)((&parentListA[ii])->nextPtr->nextPtr))->key;
-    assert((k & 3) == ii);
-    assert(((k & 15) >> 2) == 1); /* 01 */
-
-    k = ((NodeKey *)((&parentListA[ii])->nextPtr->nextPtr->nextPtr))->key;
-    assert((k & 3) == ii);
-    assert(((k & 15) >> 2) == 2); /* 10 */
-
-    k = ((NodeKey *)((&parentListA[ii])->nextPtr->nextPtr->nextPtr->nextPtr))->key;
-    assert((k & 3) == ii);
-    assert(((k & 15) >> 2) == 3); /* 11 */
-
-    urlKey.key = 0xFFAA3400 | ii;
-    assert(plaxtonCheckIfParent(urlKey, &nodes[ii]));
-    assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == ii);
+    /* 00 00 is list 4 and is empty */
+    assert(List_IsEmpty(&parentListA[4]));
+
+    /* 01 00 is list 5 and has one element "xxx0100" = 4 */
+    assert(parentListA[5].nextPtr->nextPtr == &parentListA[5]);
+    k = ((HintCacheNodeKey *) ((&parentListA[5])->nextPtr))->key;
+    assert((k & 15) == 4);
+    urlKey.key = 0xFFAA1204;
+    assert(plaxtonCheckIfParent(urlKey, &nodes[4]));
+    assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 5);
+    assert(!iAmRoot);
+
+    /* 10 00 is list 6 and has one element "xxx1000" = 8 */
+    assert(parentListA[6].nextPtr->nextPtr == &parentListA[6]);
+    k = ((HintCacheNodeKey *) ((&parentListA[6])->nextPtr))->key;
+    assert((k & 15) == 8);
+    urlKey.key = 0xFFAA1208;
+    assert(plaxtonCheckIfParent(urlKey, &nodes[8]));
+    assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 6);
     assert(!iAmRoot);
-  }
-  /*
-   * The level-1 lists 0100, 1000, 1100 should each
-   * have one element
-   */
-  /* 00 00 is list 4 and is empty */
-  assert(List_IsEmpty(&parentListA[4]));
-
-  /* 01 00 is list 5 and has one element "xxx0100" = 4 */
-  assert(parentListA[5].nextPtr->nextPtr == &parentListA[5]);
-  k = ((NodeKey *)((&parentListA[5])->nextPtr))->key;
-  assert((k & 15) == 4);
-  urlKey.key = 0xFFAA1204;
-  assert(plaxtonCheckIfParent(urlKey, &nodes[4]));
-  assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 5);
-  assert(!iAmRoot);
-
-  /* 10 00 is list 6 and has one element "xxx1000" = 8 */
-  assert(parentListA[6].nextPtr->nextPtr == &parentListA[6]);
-  k = ((NodeKey *)((&parentListA[6])->nextPtr))->key;
-  assert((k & 15) == 8);
-  urlKey.key = 0xFFAA1208;
-  assert(plaxtonCheckIfParent(urlKey, &nodes[8]));
-  assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 6);
-  assert(!iAmRoot);
-
-  /* 11 00 is list 7 and has one element "xxx1100" = 12 */
-  assert(parentListA[7].nextPtr->nextPtr == &parentListA[7]);
-  k = ((NodeKey *)((&parentListA[7])->nextPtr))->key;
-  assert((k & 15) == 12);
-  urlKey.key = 0xFFAA120C;
-  assert(plaxtonCheckIfParent(urlKey, &nodes[12]));
-  assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 7);
-  assert(!iAmRoot);
 
-  plaxtonDestroy();
+    /* 11 00 is list 7 and has one element "xxx1100" = 12 */
+    assert(parentListA[7].nextPtr->nextPtr == &parentListA[7]);
+    k = ((HintCacheNodeKey *) ((&parentListA[7])->nextPtr))->key;
+    assert((k & 15) == 12);
+    urlKey.key = 0xFFAA120C;
+    assert(plaxtonCheckIfParent(urlKey, &nodes[12]));
+    assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 7);
+    assert(!iAmRoot);
+
+    plaxtonDestroy();
 }
 
 
@@ -2340,46 +2362,47 @@
  *
  *--------------------------------------------------------5.4.1998----
  */
-static void 
-testParentsInternals2(void)
+static void testParentsInternals2(void)
 {
-  int ii;
-  struct sockaddr_in sin;
-  NodeKey anotherNodeKey;
-  URLKey urlKey;
-  int iAmRoot;
-
-  plaxtonInit(4);
-  myNodeKey = 0;   /* Fake it out to make tests easier to write and read */
-
-  ii = 0;
-  while(1){
-    /*
-     * Note: netdb only keeps distance info on granularity of
-     * networks; so make nodes be on different (hopfully unused) subnets
-     */
-    sin.sin_addr.s_addr = 15000 + ii*255;
-    sin.sin_port = 0;
-    if(netdbHintHops(sin.sin_addr) != 0){
-      ii++;
-      continue; /* Someone already used this address and gave it a distance */
+    int ii;
+    struct sockaddr_in sin;
+    HintCacheNodeKey anotherNodeKey;
+    URLKey urlKey;
+    int iAmRoot;
+
+        plaxtonInit(4);
+        myNodeKey = 0;		/* Fake it out to make tests easier to write and read */
+
+        ii = 0;
+    while (1)
+    {
+	/*
+	 * Note: netdb only keeps distance info on granularity of
+	 * networks; so make nodes be on different (hopfully unused) subnets
+	 */
+	sin.sin_addr.s_addr = 15000 + ii * 255;
+	sin.sin_port = 0;
+	if (netdbHintHops(sin.sin_addr) != 0)
+	{
+	    ii++;
+	    continue;		/* Someone already used this address and gave it a distance */
+	}
+	hintCacheNodeKeyInit(&anotherNodeKey, &sin);
+	/* 
+	 * Want 0110 0000 
+	 */
+	if ((anotherNodeKey.key & 0xFF) == 0x60) {
+	    HCHier_newNode(&sin, 1000, 999);
+	    break;
+	}
+	ii++;
     }
-    NodeKey_Init(&anotherNodeKey, &sin);
-    /* 
-     * Want 0110 0000 
-     */
-    if((anotherNodeKey.key & 0xFF) == 0x60){
-      HCHier_newNode(&sin, 1000, 999);
-      break;
-    }
-    ii++;
-  }
-  assert((anotherNodeKey.key & 0xFF) == 0x60);
-  urlKey.key = 0x20;
-  assert(plaxtonCheckIfParent(urlKey, &sin));
-  assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 22);
-  assert(!iAmRoot);
-  plaxtonDestroy();
+    assert((anotherNodeKey.key & 0xFF) == 0x60);
+    urlKey.key = 0x20;
+    assert(plaxtonCheckIfParent(urlKey, &sin));
+    assert(plaxtonParentQIndex(&urlKey, &iAmRoot) == 22);
+    assert(!iAmRoot);
+    plaxtonDestroy();
 }
 
 /*
@@ -2400,20 +2423,18 @@
  *
  *----------------------------------------------------5.4.1998------
  */
-static void 
-testMakeMatchKey(void)
+static void testMakeMatchKey(void)
 {
-  URLKey key;
-  GenericKey ret;
+    URLKey key;
+    HintCacheKey ret;
 
-  key.key = 0xFFAABBCC;
-  ret = makeMatchKey(&key, 4, 0);
-  assert(ret == 0xC);
-  ret = makeMatchKey(&key, 4, 0xD);
-  assert(ret = 0xDC);
-  ret = makeMatchKey(&key, 0, 0xD);
-  assert(ret = 0xD);
+               key.key = 0xFFAABBCC;
+               ret = makeMatchKey(&key, 4, 0);
+               assert(ret == 0xC);
+               ret = makeMatchKey(&key, 4, 0xD);
+               assert(ret = 0xDC);
+               ret = makeMatchKey(&key, 0, 0xD);
+               assert(ret = 0xD);
 }
 
-#endif /* DOTEST */
-
+#endif				/* DOTEST */
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.43.2.2
retrieving revision 1.43.2.3
diff -u -r1.43.2.2 -r1.43.2.3
--- squid/src/cf.data.pre	8 Jan 2002 09:10:39 -0000	1.43.2.2
+++ squid/src/cf.data.pre	21 May 2002 02:46:42 -0000	1.43.2.3
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.43.2.2 2002/01/08 09:10:39 hno Exp $
+# $Id: cf.data.pre,v 1.43.2.3 2002/05/21 02:46:42 jkay Exp $
 #
 #
 # SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -3649,7 +3649,7 @@
 COMMENT: bytes
 IFDEF: USE_HINT_CACHE
 TYPE: int
-LOC: Config.Hints.size;
+LOC: Config.Hints.size
 DEFAULT: 83886080
 DOC_START
 	This is the size of the hint cache, in bytes.  It has to be
@@ -3660,7 +3660,7 @@
 NAME: hint_cache_assoc
 IFDEF: USE_HINT_CACHE
 TYPE: int
-LOC: Config.Hints.assoc;
+LOC: Config.Hints.assoc
 DEFAULT: 4
 DOC_START
 	Hint cache associativity.
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.15.2.2
retrieving revision 1.15.2.3
diff -u -r1.15.2.2 -r1.15.2.3
--- squid/src/defines.h	7 Dec 2001 23:25:32 -0000	1.15.2.2
+++ squid/src/defines.h	21 May 2002 02:46:42 -0000	1.15.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.15.2.2 2001/12/07 23:25:32 jkay Exp $
+ * $Id: defines.h,v 1.15.2.3 2002/05/21 02:46:42 jkay Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -302,7 +302,9 @@
 #if USE_HINT_CACHE
 /* Hint Cache Interface */
 
-#define HINT_CACHE_VERSION "1.0"   /* Protocol version */
+/* Not QUITE compatible with 1.0 due to different tolower treatment
+   of URLs before md5 coding. */
+#define HINT_CACHE_VERSION "2.0"   /* Protocol version */
 
 /* Returns true iff the hint cache is in operation. */
 #define HINT_CACHE_ACTIVE()  (HCDisk != NULL)
@@ -315,6 +317,7 @@
 #define HCE_INVALIDATE(hce) ((hce)->ipaddr.s_addr  = INADDR_ANY, \
 			     (hce)->key = INVALID_URL_KEY);
 
+#define HINT_CACHE_KEY(e) (((URLKey *) ((e)->hchash.key)))
 
 /* Hint protocol event types */
 #define HC_InvalToParent  1
Index: squid/src/dist.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/dist.c,v
retrieving revision 1.1.2.4
retrieving revision 1.1.2.5
diff -u -r1.1.2.4 -r1.1.2.5
--- squid/src/dist.c	22 Dec 2001 16:34:33 -0000	1.1.2.4
+++ squid/src/dist.c	21 May 2002 02:46:42 -0000	1.1.2.5
@@ -1,5 +1,5 @@
 /*
- * $Id: dist.c,v 1.1.2.4 2001/12/22 16:34:33 jkay Exp $
+ * $Id: dist.c,v 1.1.2.5 2002/05/21 02:46:42 jkay Exp $
  *
  * Distribution network algorithm.
  *
@@ -35,6 +35,7 @@
 
 static char urlbuf[MAX_URL + 48];
 
+peer *DistAllPeers = 0;
 
 /* Create new updatee ds & add to object's updatee list */
 Updatee *
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.27.2.5
retrieving revision 1.27.2.6
diff -u -r1.27.2.5 -r1.27.2.6
--- squid/src/enums.h	8 Jan 2002 09:10:40 -0000	1.27.2.5
+++ squid/src/enums.h	21 May 2002 02:46:42 -0000	1.27.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.27.2.5 2002/01/08 09:10:40 hno Exp $
+ * $Id: enums.h,v 1.27.2.6 2002/05/21 02:46:42 jkay Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -736,9 +736,18 @@
 };
 
 #if USE_HINT_CACHE
-enum HintCacheNet_State {HC_uninitialized, HC_filling, HC_full, HC_destroyed};
+enum HintCacheNet_State {
+    HC_uninitialized,
+    HC_filling,
+    HC_full,
+    HC_destroyed
+};
+
 
-typedef enum HintCacheNeighborActionE {NEIGHBOR_ADD, NEIGHBOR_REMOVE} NeighborAction;
+typedef enum HintCacheNeighborActionE {
+    NEIGHBOR_ADD,
+    NEIGHBOR_REMOVE
+} NeighborAction;
 
 #endif /* USE_HINT_CACHE */
 
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.14.2.2
retrieving revision 1.14.2.3
diff -u -r1.14.2.2 -r1.14.2.3
--- squid/src/globals.h	7 Dec 2001 23:25:32 -0000	1.14.2.2
+++ squid/src/globals.h	21 May 2002 02:46:42 -0000	1.14.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.14.2.2 2001/12/07 23:25:32 jkay Exp $
+ * $Id: globals.h,v 1.14.2.3 2002/05/21 02:46:42 jkay Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -159,9 +159,17 @@
 extern int incoming_sockets_accepted;
 extern peer *DistAllPeers;
 #if USE_HINT_CACHE
+extern hash_table hint_table;
 extern const URLKey INVALID_URL_KEY;
 extern HintCacheDisk *HCDisk;
-#endif
+extern HintCacheNet *parentOutgoingA;
+extern HintCacheNet *childrenOutgoingA;
+extern HintCacheNet *neighborsOutgoing;
+extern HintCacheDisk *hcDisk;
+#if USE_DYNAMIC_HIERARCHY
+
+#endif /* USE_DYNAMIC_HIERARCHY */
+#endif /* USE_HINT_CACHE */
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 extern unsigned int WIN32_OS_version;	/* 0 */
 extern char *WIN32_OS_string;
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.17.2.4
retrieving revision 1.17.2.5
diff -u -r1.17.2.4 -r1.17.2.5
--- squid/src/http.c	8 Jan 2002 09:10:40 -0000	1.17.2.4
+++ squid/src/http.c	21 May 2002 02:46:42 -0000	1.17.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.17.2.4 2002/01/08 09:10:40 hno Exp $
+ * $Id: http.c,v 1.17.2.5 2002/05/21 02:46:42 jkay Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -1073,9 +1073,6 @@
 	    storeReleaseRequest(httpState->entry);
 	/* Use consistency protocol for this request */
 	if (peer->options.dist) {
-	    distNewUpdatee(httpState->entry,
-			   peer->in_addr.sin_addr,
-			   htons(peer->http_port));
 	    httpState->request->flags.distify = 1;
 	}
 #if DELAY_POOLS
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.28.2.4
retrieving revision 1.28.2.5
diff -u -r1.28.2.4 -r1.28.2.5
--- squid/src/main.c	8 Jan 2002 09:10:40 -0000	1.28.2.4
+++ squid/src/main.c	21 May 2002 02:46:42 -0000	1.28.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.28.2.4 2002/01/08 09:10:40 hno Exp $
+ * $Id: main.c,v 1.28.2.5 2002/05/21 02:46:42 jkay Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -346,6 +346,7 @@
     authenticateShutdown();
     storeDirCloseSwapLogs();
     errorClean();
+    distInit();
     parseConfigFile(ConfigFile);
     _db_init(Config.Log.log, Config.debugOptions);
     ipcache_restart();		/* clear stuck entries */
@@ -353,7 +354,6 @@
     fqdncache_restart();	/* sigh, fqdncache too */
     parseEtcHosts();
     errorInitialize();		/* reload error pages */
-    distInit();
 #if USE_DNSSERVERS
     dnsInit();
 #else
@@ -492,7 +492,6 @@
     httpReplyInitModule();	/* must go before accepting replies */
     errorInitialize();
     accessLogInit();
-    distInit();
 #if USE_IDENT
     identInit();
 #endif
@@ -644,6 +643,7 @@
 	eventInit();		/* eventInit() is required for config parsing */
 	storeFsInit();		/* required for config parsing */
 	authenticateSchemeInit();	/* required for config parsign */
+	distInit();             /* Needed for fwdall list */
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.41.2.5
retrieving revision 1.41.2.6
diff -u -r1.41.2.5 -r1.41.2.6
--- squid/src/protos.h	8 Jan 2002 09:10:40 -0000	1.41.2.5
+++ squid/src/protos.h	21 May 2002 02:46:42 -0000	1.41.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.41.2.5 2002/01/08 09:10:40 hno Exp $
+ * $Id: protos.h,v 1.41.2.6 2002/05/21 02:46:42 jkay Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -1353,32 +1353,30 @@
 int hintCacheInit();
 void hintCacheCreate();              /* create new cache */
 void hintCacheDestroy();
-void hintCacheInformLocalCopy(char *url, StoreEntry *); /* tell hierarchy I have a copy */
+void hintCacheInformLocalCopy(StoreEntry *); /* tell hierarchy I have a copy */
 void hintCacheInvalLocalCopy(StoreEntry *); /* say I don't have a copy */
 int hintCacheActive();  /* Ask hint cache if it is operational. */
 struct sockaddr_in *hintCachefindNearest(char *url, struct sockaddr_in *);
 
-/* Hint Cache Primitives */;
-void URLKeyInit (URLKey *key, char *url);
-void NetURLKeyInit(Net_URLKey *mungedKey, URLKey *key);
-void NetURLKeyLocalFormat(Net_URLKey *mungedKey, URLKey *key);
-
-void NodeKeyInit(NodeKey *k, const struct sockaddr_in *addrP);
-int NodeKeyCompare(const NodeKey *k1, const NodeKey *k2);
-struct sockaddr_in NodeKeyGetAddr(const NodeKey *k);
-GenericKey NodeKKKey(const struct sockaddr_in *addrP);
+void hintCacheNodeKeyInit(NodeKey *k, const struct sockaddr_in *addrP);
+int hintCacheNodeKeyCompare(const NodeKey *k1, const NodeKey *k2);
+struct sockaddr_in hintCacheNodeKeyGetAddr(const NodeKey *k);
+HintCacheKey hintCacheNodeKeyKey(const struct sockaddr_in *addrP);
 
 void hintCacheEntryInit(HintCacheEntry *, URLKey, struct sockaddr_in *,
 			   unsigned int mtime);
 int hintCacheEntryCompare(HintCacheEntry *e1, HintCacheEntry *e2);
-void hintCacheEntryInitNet(Net_HintCacheEntry *mungedEntry, HintCacheEntry *entry);
-void hintCacheEntryLocalFormatNet(Net_HintCacheEntry *mungedEntry, HintCacheEntry *entry);
+void hintCacheEntryInitNet(HintCacheEntryNet *mungedEntry, HintCacheEntry *entry);
+void hintCacheEntryLocalFormatNet(HintCacheEntryNet *mungedEntry, HintCacheEntry *entry);
 
 int hintCacheUpdateCompare(HintCacheUpdate *u1, HintCacheUpdate *u2);
 void hintCacheUpdateInit(HintCacheUpdate *, int action, HintCacheEntry *, int hopcount);
 
-void hintCacheUpdateInitNet(Net_HintCacheUpdate *mungedUpdate, HintCacheUpdate *update);
-void hintCacheUpdateLocalFormatNet(Net_HintCacheUpdate *mungedUpdate, HintCacheUpdate *update);
+void hintCacheUpdateInitNet(HintCacheUpdateNet *mungedUpdate, HintCacheUpdate *update);
+void hintCacheUpdateLocalFormatNet(HintCacheUpdateNet *mungedUpdate, HintCacheUpdate *update);
+int hintCacheURLKeyCompare(URLKey *u1, URLKey *u2);
+StoreEntry *hintCacheStoreGet(URLKey urlkey);
+
 
 /* Hint Cache Disk */
 void hintCacheDiskInit(HintCacheDisk *d, char *diskPath);
@@ -1397,66 +1395,64 @@
 void hintCacheEndian_selfTest(void);
 
 void hintCacheInitNet(HintCacheNet *n);
-int hintCacheNet_IsInitialized(void);
- void hintCacheNet_Destroy(HintCacheNet *n);
-void hintCacheNet_Enqueue(HintCacheNet *, int action,
+int hintCacheNetIsInitialized(void);
+ void hintCacheNetDestroy(HintCacheNet *n);
+void hintCacheNetEnqueue(HintCacheNet *, int action,
 			  HintCacheEntry *, int hopcount);
-int hintCacheNet_bytesReady(HintCacheNet *n);
-void hintCacheNet_Complete(HintCacheNet *n);
-void hintCacheNet_Done(HintCacheNet *n);
-void hintCacheNet_SendTo(HintCacheNet *, struct sockaddr_in *);
-void hintCacheNet_SendJoin();
-void hintCacheNet_DataArrives(char *data, int len, HintCacheNetHeader *hdr,
+int hintCacheNetBytesReady(HintCacheNet *n);
+void hintCacheNetComplete(HintCacheNet *n);
+void hintCacheNetDone(HintCacheNet *n);
+void hintCacheNetSendTo(HintCacheNet *, struct sockaddr_in *);
+void hintCacheNetSendJoin();
+void hintCacheNetDataArrives(char *data, int len, HintCacheNetHeader *hdr,
 				struct sockaddr_in *source);
-void hintCacheNet_SetTestMode(HintCacheNet *n);
-int hintCacheNet_GetTestCount(HintCacheNet *n);
+void hintCacheNetSetTestMode(HintCacheNet *n);
+int hintCacheNetGetTestCount(HintCacheNet *n);
 
-void hintCacheProp_LocalAction(StoreEntry *, int action);
-void hintCacheProp_HandleInvalToChild(HintCacheUpdate *update,
+void hintCachePropLocalAction(StoreEntry *, int action);
+void hintCachePropHandleInvalToChild(HintCacheUpdate *update,
 				      struct sockaddr_in *src, int local);
-void hintCacheProp_HandleInformToChild(HintCacheUpdate *update,
+void hintCachePropHandleInformToChild(HintCacheUpdate *update,
 				       struct sockaddr_in *src, int local) ;
-void hintCacheProp_HandleInvalToParent(HintCacheUpdate *update,
+void hintCachePropHandleInvalToParent(HintCacheUpdate *update,
 				       struct sockaddr_in *src, int local);
-void hintCacheProp_HandleInformToParent(HintCacheUpdate *update,
+void hintCachePropHandleInformToParent(HintCacheUpdate *update,
 					struct sockaddr_in *src, int local);
 
-void hintCacheNodelist_Init(); /* constructor */
-void hintCacheNodelist_Destroy(); /* destructor */
-void hintCacheNodelist_SelfTest();
-void hintCacheNodelist_LocalJoin(); /* I do a join */
-void hintCacheNodelist_LocalLeave(); /* I do a leave */
-int hintCacheNodelist_myStatus(); /* Am I in or out? */
-void hintCacheNodelist_NetJoin(struct sockaddr_in *sin, int hops, long long timeNS);
-void hintCacheNodelist_NetLeave(struct sockaddr_in *sin, int hops, long long timeNS);
-void hintCacheNodeList_IterStart(HintCacheNodeListIter *iter);
-int hintCacheNodeList_IterCheck(HintCacheNodeListIter iter);
-void hintCacheNodeList_IterNext(HintCacheNodeListIter *iter);
-int hintCacheNodeList_IterGetAddr(HintCacheNodeListIter iter,
+void hintCacheNodelistInit(); /* constructor */
+void hintCacheNodelistDestroy(); /* destructor */
+void hintCacheNodelistSelfTest();
+void hintCacheNodelistLocalJoin(); /* I do a join */
+void hintCacheNodelistLocalLeave(); /* I do a leave */
+int hintCacheNodelistMyStatus(); /* Am I in or out? */
+void hintCacheNodelistNetJoin(struct sockaddr_in *sin, int hops, long long timeNS);
+void hintCacheNodelistNetLeave(struct sockaddr_in *sin, int hops, long long timeNS);
+void hintCacheNodelistIterStart(HintCacheNodeListIter *iter);
+int hintCacheNodelistIterCheck(HintCacheNodeListIter iter);
+void hintCacheNodelistIterNext(HintCacheNodeListIter *iter);
+int hintCacheNodelistIterGetAddr(HintCacheNodeListIter iter,
 				  struct sockaddr_in *ret);
-void hintCacheNodelist_addMembershipNeighbor(struct sockaddr_in *neighbor);
-void hintCacheNodelist_rmMembershipNeighbor(struct sockaddr_in *neighbor);
 
-void hintCacheHier_updateMembershipNeighbor(struct sockaddr_in *neighbor, 
+void hintCacheHierUpdateMembershipNeighbor(struct sockaddr_in *neighbor, 
                                      NeighborAction);
-void hintCacheHier_Init();
-void hintCacheHier_Destroy();
-int hintCacheHier_compareDistanceFromMe(struct in_addr new, struct in_addr old);
-void hintCacheHier_newNode(struct sockaddr_in *sin, int hops, long long time);
-void hintCacheHier_delNode(struct sockaddr_in *sin, int hops, long long time);
-int hintCacheHier_CheckIfParent(URLKey key, struct sockaddr_in *candidate);
-int hintCacheHier_CheckIfChild(struct sockaddr_in *candidate);
-void hintCacheHier_AddChild(struct sockaddr_in *child);
-void hintCacheHier_RemoveChild(struct sockaddr_in *child);
-int hintCacheHier_NChildrenQs();
-int hintCacheHier_ChildQIndex(URLKey *key, int iAmRoot, int *amILeaf);
-int hintCacheHier_GetChildAddrs(int qIndex, struct sockaddr_in **retAddr);
-int hintCacheHier_NParentQs();
-int hintCacheHier_ParentQIndex(URLKey *key, int *amIRoot);
-int hintCacheHier_GetParentAddr(int index, struct sockaddr_in *retAddr);
-int hintCacheHier_SendToParent(struct sockaddr_in *src, HintCacheUpdate *update,
+void hintCacheHierInit();
+void hintCacheHierDestroy();
+int hintCacheHierCompareDistanceFromMe(struct in_addr new, struct in_addr old);
+void hintCacheHierNewNode(struct sockaddr_in *sin, int hops, long long time);
+void hintCacheHierDelNode(struct sockaddr_in *sin, int hops, long long time);
+int hintCacheHierCheckIfParent(URLKey key, struct sockaddr_in *candidate);
+int hintCacheHierCheckIfChild(struct sockaddr_in *candidate);
+void hintCacheHierAddChild(struct sockaddr_in *child);
+void hintCacheHierRemoveChild(struct sockaddr_in *child);
+int hintCacheHierNChildrenQs();
+int hintCacheHierChildQIndex(URLKey *key, int iAmRoot, int *amILeaf);
+int hintCacheHierGetChildAddrs(int qIndex, struct sockaddr_in **retAddr);
+int hintCacheHierNParentQs();
+int hintCacheHierParentQIndex(URLKey *key, int *amIRoot);
+int hintCacheHierGetParentAddr(int index, struct sockaddr_in *retAddr);
+int hintCacheHierSendToParent(struct sockaddr_in *src, HintCacheUpdate *update,
 				 int msgtype);
-int hintCacheHier_SendToSiblings(struct sockaddr_in *src, HintCacheUpdate *update,
+int hintCacheHierSendToSiblings(struct sockaddr_in *src, HintCacheUpdate *update,
 				   int msgtype, int siblingtype);
 
 #ifdef USE_DYNAMIC_HIERARCHY
@@ -1479,8 +1475,8 @@
 int plaxtonCheckIfChild(struct sockaddr_in *candidate);
 void plaxtonAddChild(struct sockaddr_in *child);
 void plaxtonRemoveChild(struct sockaddr_in *child);
-int plaxtonMatchBits(GenericKey k1, GenericKey k2);
-GenericKey plaxtonMyNodeKey();
+int plaxtonMatchBits(HintCacheKey k1, HintCacheKey k2);
+HintCacheKey plaxtonMyNodeKey();
 
 extern int Plaxton_BucketsPerLevel;
 extern HintCacheNet *Plaxton_parentOutgoingA;
Index: squid/src/put.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/put.c,v
retrieving revision 1.1.2.5
retrieving revision 1.1.2.6
diff -u -r1.1.2.5 -r1.1.2.6
--- squid/src/put.c	22 Dec 2001 16:34:33 -0000	1.1.2.5
+++ squid/src/put.c	21 May 2002 02:46:43 -0000	1.1.2.6
@@ -1,5 +1,5 @@
 /*
- * $Id: put.c,v 1.1.2.5 2001/12/22 16:34:33 jkay Exp $
+ * $Id: put.c,v 1.1.2.6 2002/05/21 02:46:43 jkay Exp $
  *
  * DEBUG: section 81  PUT transmission and reception
  * AUTHOR: Jon Kay, 1997
@@ -147,7 +147,7 @@
 		
 	        sin.sin_family = AF_INET;
 		sin.sin_addr = p->in_addr.sin_addr;
-		sin.sin_port = p->http_port;
+		sin.sin_port = htons(p->http_port);
 		putSend(entry, &sin, NULL, NULL, 0);
 #if USE_ICP_DATA
 	    }
